<?php

/**
 * @file
 * Functions for the generation of the CAPTCHA image.
 */

/**
 * Menu callback function that generates the CAPTCHA image.
 */
function chinese_captcha_image() {
  header("Content-type: image/PNG");
  $w = 150;
  $h = 50;
  //font file path
  $fontface = drupal_get_path('module', 'chinese_captcha') . '/font/fzcyjt.ttf';

  $code = variable_get('chinese_captcha_session_code');
  $code = iconv('utf-8', 'GB2312', $code);
  $im = imagecreatetruecolor($w, $h);
  $bkcolor = imagecolorallocate($im, 250, 250, 250);
  imagefill($im, 0, 0, $bkcolor);

  /***Add interference***/
  for ($i = 0; $i < 15; $i++) {
    $fontcolor = imagecolorallocate($im, mt_rand(0, 255), mt_rand(0, 255), mt_rand(0, 255));
    imagearc($im, mt_rand(-10, $w), mt_rand(-10, $h), mt_rand(30, 300), mt_rand(20, 200), 55, 44, $fontcolor);
  }

  for ($i = 0; $i < 255; $i++) {
    $fontcolor = imagecolorallocate($im, mt_rand(0, 255), mt_rand(0, 255), mt_rand(0, 255));
    imagesetpixel($im, mt_rand(0, $w), mt_rand(0, $h), $fontcolor);
  }

  /***Image content***/
  for ($i = 0; $i < 4; $i++) {
    $fontcolor = imagecolorallocate($im, mt_rand(0, 120), mt_rand(0, 120), mt_rand(0, 120));
    $codex = iconv("GB2312", "UTF-8", substr($code, $i * 2, 2));
    imagettftext($im, mt_rand(14, 18), mt_rand(-60, 60), 30 * $i + 20, mt_rand(30, 35), $fontcolor, $fontface, $codex);
  }

  imagepng($im);
  imagedestroy($im);
}
